/**vim: ts=4, wrap, tw=80
  *
  *		--- libkvibiffconfig.h ---
  *
  * (c) Krzysztof Godlewski <kristoff@poczta.wprost.pl>
  * 
  * This program is FREE software. You can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your opinion) any later version.
  *
  * This program is distributed in the HOPE that it will be USEFUL,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  * See the GNU General Public License for more details.

  * You should have received a copy of the GNU General Public License
  * along with this program. If not, write to the Free Software Foundation,
  * Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  **/
 
#ifndef __LIBKVIBIFFCONFIG_H__
#define __LIBKVIBIFFCONFIG_H__

#include <qpushbutton.h>
#include <qtabdialog.h>
#include <qvbox.h>
#include "kvi_listview.h"

class KviBiffConfigDlg : public QTabDialog
{
	Q_OBJECT
	
public:
	KviBiffConfigDlg();
	~KviBiffConfigDlg();

	void setOptions();
	void getOptions();

	void activateMailboxesTab() const;

private:
	KviListView *m_mboxView;

private slots:
	void slotAddMailbox();
	void slotRemoveMailbox();
	void slotRemoveAll();
};

#endif		// ! __LIBKVIBIFFCONFIG_H__
