#ifndef __LIBKVIEDITOR_H_INCLUDED__
#define __LIBKVIEDITOR_H_INCLUDED__

//
//   THIS IS A PLUGIN FOR THE KVIrc IRC CLIENT
//   Copyright (C) 1999-2000 Szymon Stefanek (kvirc@tin.it)
//
//   This program is FREE software. You can redistribute it and/or
//   modify it under the terms of the GNU General Public License
//   as published by the Free Software Foundation; either version 2
//   of the License, or (at your opinion) any later version.
//
//   This program is distributed in the HOPE that it will be USEFUL,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
//   See the GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program. If not, write to the Free Software Foundation,
//   Inc. ,59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#include "kvi_window.h"
#include "editor.h"

//#include <qscrollview.h>
//#include <qimage.h>

#include <qmenubar.h>

class KviEditorWindow : public KviWindow
{
	Q_OBJECT
public:		// Consruction & Destruction
	KviEditorWindow(KviFrame *lpFrm);
	~KviEditorWindow();
public:		// Fields
	QMenuBar   * m_pMenuBar;
	SSEXEditor * m_pEditor;
public:
	void openFile(const char *name);
public slots:
	void newFile();
	void openFile();
	void fileNameChanged(SSEXEditor *ed,const QCString &fileName);
protected:	// Protected methods
	virtual QPixmap * myIconPtr();
	virtual void resizeEvent(QResizeEvent *);
	virtual void closeEvent(QCloseEvent *e);
};




#endif //!__LIBKVIXMMS_H_INCLUDED__
